%Code for Compact Image Representation/Compression using Sparse Matrix Projections onto Exemplar Orthonormal Bases, (version %0.0.1):
%----------------------------------------------------
% Copyright (C) 2009 Karthik Gurumoorthy, Ajit Rajwade, Arunava Banerjee and Anand Rangarajan
% 
% Authors: Karthik Gurumoorthy, Ajit Rajwade, Arunava Banerjee and Anand Rangarajan
% Date:    19th Nov 2009
% 
% Contact Information:
%
%Karthik Gurumoorthy: ksg@cise.ufl.edu
% Ajit Rajwade:	avr@cise.ufl.edu
% Arunava Banerjee: arunava@cise.ufl.edu
% Anand Rangarajan: anand@cise.ufl.edu
%
% Terms:	  
% 
% The source code is provided under the
% terms of the GNU General Public License (version 2).
%



function multiImgRepresentation(databaseName,trainImgDirectory,patchSize,M,testImgDirectory,errTh,errTag,fracBit,ext,T)
    str_uv = strcat('_',databaseName,'_',num2str(patchSize(1)),'X',num2str(patchSize(2)));
    str_uv = strcat(str_uv,'_',num2str(M),'_',num2str(T));
    str = strcat(str_uv,'_',errTag,'_',num2str(fracBit));
    X = getPatchesFromMultipleImages(trainImgDirectory,patchSize,ext);
    fprintf('I am done reading!!!\n');
    X = X / max(max(max(X)));
    [U,V] = mixtureSVD(X,patchSize,M,T,str_uv);
    u_fileName = strcat('U',str_uv);
    v_fileName = strcat('V',str_uv);
    delete(strcat(u_fileName,'.mat'));
    delete(strcat(v_fileName,'.mat'));
    save(u_fileName,'U');
    save(v_fileName,'V');
    testNewImage(U,V,patchSize,testImgDirectory,str,errTh,fracBit,ext);
end
